/*
 * arith.h -- 64 bit arithmetic
 */


#ifndef _ARITH_H_
#define _ARITH_H_


#include "common.h"


extern octa zero;			/* 0 */
extern octa one;			/* 1 */
extern octa negone;			/* -1 */

extern octa arithAuxOut;
extern bool arithOvrflw;


octa incrOcta(octa x, int delta);

octa addOcta(octa x, octa y);
octa subOcta(octa x, octa y);
octa umulOcta(octa x, octa y);		/* sets arithAux */
octa smulOcta(octa x, octa y);		/* sets arithAux */
octa udivOcta(octa x, octa y, octa z);	/* sets arithAux */
octa sdivOcta(octa x, octa y);		/* sets arithAux */

octa orOcta(octa x, octa y);
octa ornOcta(octa x, octa y);
octa norOcta(octa x, octa y);
octa xorOcta(octa x, octa y);
octa andOcta(octa x, octa y);
octa andnOcta(octa x, octa y);
octa nandOcta(octa x, octa y);
octa nxorOcta(octa x, octa y);

octa shlOcta(octa x, int n);
octa shrOcta(octa x, int n);
octa sarOcta(octa x, int n);


#endif /* _ARITH_H_ */
