/*
 * error.h -- error handler
 */


#ifndef _ERROR_H_
#define _ERROR_H_


#include "common.h"

#include <setjmp.h>


#define NO_EXCEPTION		0
#define BUS_EXCEPTION		1
#define ADDRESS_EXCEPTION	2
#define INSTRUCTION_EXCEPTION	3
#define DIVIDE_EXCEPTION	4
#define NUM_EXCEPTIONS		5


char *exceptionToString(int exception);
void throwException(int exception);
void pushEnvironment(jmp_buf *environment);
void popEnvironment(void);

void error(char *fmt, ...);


#endif /* _ERROR_H_ */
