/*
 * mmu.h -- MMU simulation
 */


#ifndef _MMU_H_
#define _MMU_H_


#include "common.h"


octa mmuRead64(octa vAddr);
tetra mmuRead32(octa vAddr);
wyde mmuRead16(octa vAddr);
byte mmuRead8(octa vAddr);
void mmuWrite64(octa vAddr, octa data);
void mmuWrite32(octa vAddr, tetra data);
void mmuWrite16(octa vAddr, wyde data);
void mmuWrite8(octa vAddr, byte data);

void mmuReset(void);
void mmuInit(void);
void mmuExit(void);


#endif /* _MMU_H_ */
