/*
 * stdctest.c -- GIMMIX standard C library test
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>


void error(char *fmt, ...) {
  va_list ap;

  va_start(ap, fmt);
  fprintf(stderr, "Error: ");
  vfprintf(stderr, fmt, ap);
  fprintf(stderr, "\n");
  va_end(ap);
  exit(1);
}


int main(int argc, char *argv[]) {
  int i;

  for (i = 0; i < argc; i++) {
    printf("%d: %s\n", i, argv[i]);
  }
  return 0;
}
